"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = search;
var _crossFetch = _interopRequireDefault(require("cross-fetch"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _awaitAsyncGenerator(e) { return new _OverloadYield(e, 0); }
function _wrapAsyncGenerator(e) { return function () { return new AsyncGenerator(e.apply(this, arguments)); }; }
function AsyncGenerator(e) { var r, t; function resume(r, t) { try { var n = e[r](t), o = n.value, u = o instanceof _OverloadYield; Promise.resolve(u ? o.v : o).then(function (t) { if (u) { var i = "return" === r ? "return" : "next"; if (!o.k || t.done) return resume(i, t); t = e[i](t).value; } settle(n.done ? "return" : "normal", t); }, function (e) { resume("throw", e); }); } catch (e) { settle("throw", e); } } function settle(e, n) { switch (e) { case "return": r.resolve({ value: n, done: !0 }); break; case "throw": r.reject(n); break; default: r.resolve({ value: n, done: !1 }); } (r = r.next) ? resume(r.key, r.arg) : t = null; } this._invoke = function (e, n) { return new Promise(function (o, u) { var i = { key: e, arg: n, resolve: o, reject: u, next: null }; t ? t = t.next = i : (r = t = i, resume(e, n)); }); }, "function" != typeof e.return && (this.return = void 0); }
AsyncGenerator.prototype["function" == typeof Symbol && Symbol.asyncIterator || "@@asyncIterator"] = function () { return this; }, AsyncGenerator.prototype.next = function (e) { return this._invoke("next", e); }, AsyncGenerator.prototype.throw = function (e) { return this._invoke("throw", e); }, AsyncGenerator.prototype.return = function (e) { return this._invoke("return", e); };
function _OverloadYield(e, d) { this.v = e, this.k = d; }
const apiEndPoint = 'https://api.bing.microsoft.com/v7.0/images/search';
const HEADERS = {
  API_KEY: 'Ocp-Apim-Subscription-Key',
  CLIENT_ID: 'X-MSEdge-ClientID',
  CLIENT_IP: 'X-MSEdge-ClientIP',
  LOCATION: 'X-Search-Location',
  ACCEPT: 'Accept'
};
const acceptHeaderValue = 'application/json';
function filterNulls(obj) {
  return Object.keys(obj).filter(key => obj[key] != null).reduce((acc, key) => {
    acc[key] = obj[key];
    return acc;
  }, {});
}
function stringify(obj) {
  return Object.keys(obj).map(k => `${encodeURIComponent(k)}=${encodeURIComponent(obj[k])}`).join('&');
}
function search() {
  return _search.apply(this, arguments);
}
function _search() {
  _search = _wrapAsyncGenerator(function* ({
    key,
    query,
    market,
    safeSearch,
    aspect,
    color,
    imageContent,
    imageType,
    license,
    freshness,
    size,
    width,
    height,
    minWidth,
    minHeight,
    maxWidth,
    maxHeight,
    minFileSize,
    maxFileSize,
    offset = 0,
    count = 150,
    amount = 2000,
    clientID,
    clientIP,
    location,
    queryParams,
    headerParams,
    fetchCb = _crossFetch.default
  } = {}) {
    let currOffset = offset;
    let currAmount = amount;
    let available = currOffset + currAmount;
    let responseClientID;
    while (currOffset < Math.min(currOffset + currAmount, available)) {
      const requestParams = filterNulls(_objectSpread({
        q: query,
        mkt: market,
        safeSearch,
        aspect,
        color,
        imageContent,
        imageType,
        license,
        freshness,
        size,
        width,
        height,
        minWidth,
        minHeight,
        maxWidth,
        maxHeight,
        minFileSize,
        maxFileSize,
        offset: currOffset,
        count: Math.min(count, Math.min(currOffset + currAmount, available) - currOffset)
      }, queryParams));
      const requestHeaders = filterNulls(_objectSpread({
        [HEADERS.API_KEY]: key,
        [HEADERS.CLIENT_ID]: clientID === undefined ? responseClientID : clientID,
        [HEADERS.CLIENT_IP]: clientIP,
        [HEADERS.LOCATION]: location,
        [HEADERS.ACCEPT]: acceptHeaderValue
      }, headerParams));
      const requestOptions = {
        method: 'GET',
        headers: requestHeaders
      };
      const requestUrl = `${apiEndPoint}?${stringify(requestParams)}`;
      const response = yield _awaitAsyncGenerator(fetchCb(requestUrl, requestOptions));
      const ok = response.ok,
        status = response.status,
        statusText = response.statusText;
      if (!ok) {
        throw new Error(`HTTP error ${status}: "${statusText}"`);
      }
      const body = yield _awaitAsyncGenerator(response.json());
      currOffset = body.nextOffset;
      currAmount -= body.value.length;
      available = body.totalEstimatedMatches;
      responseClientID = response.headers.get(HEADERS.CLIENT_ID);
      yield body;
    }
  });
  return _search.apply(this, arguments);
}
module.exports = exports["default"];